#ifndef OBJ_H
#define OBJ_H

#include "aliases.h"
#include "img.h"
#include "mem_arena.h"
#include "typed_list.h"

#define NULL_MODEL ((Model){0})
#define IS_NULL_MODEL(m) (m.vertices == NULL || m.triangles == NULL)

typedef struct vertex Vertex;
struct vertex {
  f32 x;
  f32 y;
  f32 z;
};

typedef struct triangle Triangle;
struct triangle {
  u64 p0;
  u64 p1;
  u64 p2;
};

MAKE_LIST_TYPE(Vertex);
MAKE_LIST_TYPE(Triangle);

typedef struct model Model;
struct model {
  LIST_TYPE(Vertex) * vertices;
  LIST_TYPE(Triangle) * triangles;
};

Model load_obj_file(Arena *arena, const char *filename);
void render_wireframe_model(const Model *model, Image *img, Colour colour);

#endif // OBJ_H
